package com.image_scaler_v2
{
    import flash.utils.getTimer;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.Rectangle;
	import com.util.ColorMatrix;
	import flash.filters.ColorMatrixFilter;	
	
	public class Slider extends MovieClip
	{
		
        private var _mc, _control:MovieClip;
		private var _slide_pos, _slide_dest, _vspeed, _drag: Number;
		private var _mousedown: Boolean;
		
		public function Slider():void
		{
			_mc = this;
			_mc.buttonMode = true;
			_slide_pos = 360;
			_slide_dest = 360;
			_drag = 0.95;
			_mousedown = false;
			_vspeed = 0;
			_mc.addEventListener(MouseEvent.MOUSE_DOWN,_begin_slide);
			//_manage_slide(null);
		}
		
		public function set control($c:MovieClip):void
		{
			_control = $c;
			_control.slide(_slide_pos);
		}
		
		private function _begin_slide($evt:MouseEvent):void
		{
			stage.addEventListener(MouseEvent.MOUSE_UP,_mouse_up);
			//var _rect:Rectangle = new Rectangle(0,0,500,500);
			_mc.addEventListener(Event.ENTER_FRAME,_manage_slide);
			_mousedown = true;
		}
		
		public function button_pushed($num:Number):void
		{
			_slide_dest = $num + 33;
			if (_slide_dest<0) _vspeed = 1;
			else _vspeed = 1;
			_mc.addEventListener(Event.ENTER_FRAME,_manage_slide);
		}
		
		private function _manage_slide($evt:Event):void
		{
			if (_mousedown) _slide_dest = _control.mouseY;
			else if (_vspeed == 0) _end_slide();
			var d = _slide_dest - _slide_pos;
			var a = -_vspeed*_vspeed/(2*d);
			if (Math.abs(d)>2)
			{
				var c = 1;
				if (Math.abs(d)>20) c = 2;
				if (Math.abs(a)<c) _vspeed += c*Math.abs(d)/d;
				else _vspeed += a;
				if (Math.abs(_vspeed)>40) _vspeed = 40*Math.abs(_vspeed)/_vspeed;
				_slide_pos += _vspeed;
				if (_slide_pos<70)
				{
					_slide_pos = 70;
					_slide_dest = 70;
					_vspeed = 0;
				}
				if (_slide_pos>650)
				{
					_slide_pos = 650;
					_vspeed = 0;
				}
				_mc.y = _slide_pos;
				var theta = Math.asin((360-_slide_pos)/2956);
				_mc.x = 178 + 2956 * (1-Math.cos(theta));
				_mc.slider_tab_mc.rotation = 180*theta/Math.PI;
				_control.slide(_slide_pos-70);
				var cm:com.util.ColorMatrix = new com.util.ColorMatrix();
				cm.adjustColor(0, 0, 0, 120*(_slide_pos - 70)/580);
				_mc.slider_tab_mc.slider_color_mc.filters = [new ColorMatrixFilter(cm)];
				
			}
			else _vspeed = 0;
		}
		
		private function _mouse_up($evt:MouseEvent):void
		{
			stage.removeEventListener(MouseEvent.MOUSE_UP,_end_slide);
			_mousedown = false;
		}

		private function _end_slide():void
		{
			_mc.removeEventListener(Event.ENTER_FRAME,_manage_slide);
			_control.hide_labels();
		}
		
		public function set slide_dest($num:Number):void
		{
		}

	}
}
