package com.image_scaler_v2
{
    import flash.utils.getTimer;
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.geom.Rectangle;
	import com.util.ColorMatrix;
	import flash.filters.ColorMatrixFilter;	
	import flash.utils.*;
	import gs.*;
	import flash.text.*;
	
	public class Viewer extends MovieClip
	{
		
        private var _mc, _control:MovieClip;
		private var _xml:XML;
		
		public function Viewer():void
		{
			_mc = this;
			_mc.visible = false;
			_mc.alpha = 0;
		}
		
		public function set control($c:MovieClip):void
		{
			_control = $c;
		}

		public function show_image($xml:XML):void
		{
			_xml = $xml;
			while (_mc.image_mc.numChildren>0) _mc.image_mc.removeChildAt(0);
			var v = imageFromLib(_xml.filename_txt[0].toString());
			var bmp1:Bitmap = new Bitmap(v);
			_mc.image_mc.addChild(bmp1);
			_mc.title_txt.wordWrap = true;
			_mc.title_txt.autoSize = TextFieldAutoSize.LEFT;
			_mc.title_txt.text = _xml.title_txt[0].toString();
			_mc.title_txt.x = _mc.image_mc.width + 70;
			_mc.scale_txt.wordWrap = true;
			_mc.scale_txt.autoSize = TextFieldAutoSize.LEFT;
			if (_xml.size_txt[0].toString()!="") _mc.scale_txt.text = "Scale: " + _xml.size_txt[0].toString();
			else _mc.scale_txt.text = "";
			_mc.scale_txt.x = _mc.image_mc.width + 70;
			_mc.scale_txt.y = _mc.title_txt.height + 38;
			_mc.description_txt.wordWrap = true;
			_mc.description_txt.autoSize = TextFieldAutoSize.LEFT;
			_mc.description_txt.htmlText = _xml.caption_txt[0].toString() + "\r\r"+_xml.description_txt[0].toString();
			_mc.description_txt.x = _mc.image_mc.width + 70;
			_mc.description_txt.y = _mc.scale_txt.height + _mc.scale_txt.y + 15;
			TweenLite.to(_mc,0.3,{autoAlpha:1,onComplete:finish_show});
			_mc.author_txt.wordWrap = true;
			_mc.author_txt.autoSize = TextFieldAutoSize.LEFT;
			_mc.author_txt.text = _xml.credit_line_txt[0].toString();
			_mc.author_txt.x = 50;
			_mc.author_txt.y = _mc.image_mc.height + 30;
		}
		
		private function finish_show():void
		{
			stage.addEventListener(MouseEvent.CLICK,_close_this);
		}

		private function imageFromLib(source_ID:String):BitmapData
		{
			var classRef:Class = getDefinitionByName(source_ID) as Class;
			return new classRef(classRef.width, classRef.height);
		}
		
		private function _close_this(event:Event):void
		{
			TweenLite.to(_mc,0.3,{autoAlpha:0});
			stage.removeEventListener(MouseEvent.CLICK,_close_this);
		}
		
	}
}
